#include "AFP.h"

class AFPSlave {
  public:
    char request[AFP_FIELD_MAX];
    char request_msg[AFP_FIELD_MAX];
    char fieldNames[AFP_FIELD_N_MAX][AFP_FIELD_MAX];
    char fieldValues[AFP_FIELD_N_MAX][AFP_FIELD_MAX];
    bool fieldEnabled[AFP_FIELD_N_MAX];
    AFPSlave(char id, int rxPin);
    void begin();
    int pollRequest();
    void sendReply();
    void listenReply();
    int addField(const char* field_name);
    void enableField(int field_id);
    void disableField(int field_id);
    void disableAllFields();
    void updateField(int field_id, const char* txt, bool add_quotes);
    void setBaud(unsigned long baud);
    char getId();
  private:
    void enableSleep();
    void disableWrite();
    void enableWrite();
    char _id;
    int _rxPin;
    int _nField;
    bool _ready;
    unsigned long _baud;
};
